searchData={"content_type":"text/markdown","items":[{"doc":"Generate CMake buiid scripts and then build/install the application.\r\n\r\n$ mix cmake [opt] [build_dir] [source_dir]","ref":"Mix.Tasks.Cmake.html","title":"mix cmake","type":"task"},{"doc":"* `--config`      - generate build script\r\n* `--generator`   - specify generator\r\n* `--parallel`    - parallel jobs level\r\n* `--target`      - build target\r\n* `--clean-first` - clean before build target\r\n* `--strip`       - remove debug info from executable\r\n* `--verbose`     - print process detail","ref":"Mix.Tasks.Cmake.html#module-command-line-options","title":"Command line options - mix cmake","type":"task"},{"doc":"Add following configurations at project/1 in your mix.exs if you need.\r\n\r\n```elixir\r\ndef project do\r\n  [\r\n    cmake: [...]\r\n  ]\r\nend\r\n```\r\n\r\n* `:build_dir`  - working directory {:local, :global, any_directory}\r\n* `:source_dir` - source directory\r\n* `:generator`  - specify generator\r\n* `:build_parallel_level` - parallel jobs level","ref":"Mix.Tasks.Cmake.html#module-configuration","title":"Configuration - mix cmake","type":"task"},{"doc":"Add an environment variable for child process.","ref":"Mix.Tasks.Cmake.html#add_env/3","title":"Mix.Tasks.Cmake.add_env/3","type":"function"},{"doc":"Get application name.","ref":"Mix.Tasks.Cmake.html#app_name/0","title":"Mix.Tasks.Cmake.app_name/0","type":"function"},{"doc":"Returns true if the build directory exists.","ref":"Mix.Tasks.Cmake.html#build_dir_exists?/1","title":"Mix.Tasks.Cmake.build_dir_exists?/1","type":"function"},{"doc":"Invoke cmake command with `args`.","ref":"Mix.Tasks.Cmake.html#cmake/3","title":"Mix.Tasks.Cmake.cmake/3","type":"function"},{"doc":"Return a map of default environment variables.","ref":"Mix.Tasks.Cmake.html#default_env/0","title":"Mix.Tasks.Cmake.default_env/0","type":"function"},{"doc":"Get :cmake configuration from Mix.exs.","ref":"Mix.Tasks.Cmake.html#get_config/0","title":"Mix.Tasks.Cmake.get_config/0","type":"function"},{"doc":"Get build/source directory.","ref":"Mix.Tasks.Cmake.html#get_dirs/2","title":"Mix.Tasks.Cmake.get_dirs/2","type":"function"},{"doc":"","ref":"Mix.Tasks.Cmake.html#next/2","title":"Mix.Tasks.Cmake.next/2","type":"function"},{"doc":"parse command line arguments. (custom)","ref":"Mix.Tasks.Cmake.html#parse_argv/2","title":"Mix.Tasks.Cmake.parse_argv/2","type":"function"},{"doc":"Remove cmake build directory. (interpret pseudo-path)","ref":"Mix.Tasks.Cmake.html#remove_build/1","title":"Mix.Tasks.Cmake.remove_build/1","type":"function"},{"doc":"","ref":"Mix.Tasks.Cmake.html#remove_cache/1","title":"Mix.Tasks.Cmake.remove_cache/1","type":"function"},{"doc":"","ref":"Mix.Tasks.Cmake.html#run/1","title":"Mix.Tasks.Cmake.run/1","type":"function"},{"doc":"Build the CMake application.\r\n\r\n$ mix cmake.build [opt] [build_dir] [++ CMake options]","ref":"Mix.Tasks.Cmake.Build.html","title":"mix cmake.build","type":"task"},{"doc":"* `--parallel  `    - parallel jobs level\r\n* `--target  ` - build target\r\n* `--clean-first`     - clean before build target\r\n* `--verbose`         - print process detail","ref":"Mix.Tasks.Cmake.Build.html#module-command-line-options","title":"Command line options - mix cmake.build","type":"task"},{"doc":"* `:build_dir`            - working directory\r\n* `:build_parallel_level` - parallel jobs level\r\n* `:build_config`         - build configuration (with Visual C++)\r\n* `:target  `      - build target if command line options has no `--target`.","ref":"Mix.Tasks.Cmake.Build.html#module-configuration","title":"Configuration - mix cmake.build","type":"task"},{"doc":"Clean outputs of Cmake.\r\n\r\n$ mix cmake.clean [opt]","ref":"Mix.Tasks.Cmake.Clean.html","title":"mix cmake.clean","type":"task"},{"doc":"* `--all`     - remove cmake build directory.\r\n* `--verbose` - print process detail","ref":"Mix.Tasks.Cmake.Clean.html#module-command-line-options","title":"Command line options - mix cmake.clean","type":"task"},{"doc":"Generate build scripts based on the 'CMakeLists.txt'.\r\n\r\n$ mix cmake.config [opt] [build_dir] [source_dir] [++ CMake options]","ref":"Mix.Tasks.Cmake.Config.html","title":"mix cmake.config","type":"task"},{"doc":"* `--generator`              - specify generator.\r\n* `--define \" = \"` - create or update a CMake CACHE entry.\r\n* `--undef  `            - remove the entry from CMake CACHE.\r\n* `--trace`                  - put cmake in trace mode.\r\n* `--recache`                - remove CMakeCache.txt.","ref":"Mix.Tasks.Cmake.Config.html#module-command-line-options","title":"Command line options - mix cmake.config","type":"task"},{"doc":"* `:build_dir`  - working directory\r\n* `:source_dir` - source directory\r\n* `:generator`  - specify generator","ref":"Mix.Tasks.Cmake.Config.html#module-configuration","title":"Configuration - mix cmake.config","type":"task"},{"doc":"Create CMakeLists.txt\r\n\r\n$ mix cmake.init [source_dir]","ref":"Mix.Tasks.Cmake.Init.html","title":"mix cmake.init","type":"task"},{"doc":"Install the application to the project's priv.\r\n\r\n$ mix cmake.install [opt] [build_dir]","ref":"Mix.Tasks.Cmake.Install.html","title":"mix cmake.install","type":"task"},{"doc":"* `--strip`    - remove debug info from executable\r\n* `--verbose`  - print process detail","ref":"Mix.Tasks.Cmake.Install.html#module-command-line-options","title":"Command line options - mix cmake.install","type":"task"},{"doc":"* `:build_dir` - working directory","ref":"Mix.Tasks.Cmake.Install.html#module-configuration","title":"Configuration - mix cmake.install","type":"task"},{"doc":"Runs `cmake` in the current project.\r\n\r\nIt will skip execution cmake if the build directory exists.\r\nYou can invoke `mix cmake --config` instead, if you want to cmake again.","ref":"Mix.Tasks.Compile.Cmake.html","title":"mix compile.cmake","type":"task"},{"doc":"This compiler can be configured through the return value of the `project/0`\r\nfunction in `mix.exs`; for example:\r\n\r\n```elixir\r\ndef project() do\r\n  [\r\n    app: :myapp,\r\n    deps: deps(),\r\n    compilers: [:cmake] ++ Mix.compilers,\r\n    \r\n    cmake: [\r\n      build_dir: :local,\r\n      build_parallel_level: 4\r\n    ]\r\n  ]\r\nend\r\n```\r\n\r\n* `:build_dir`  - working directory {:local, :global, any_directory}\r\n* `:source_dir` - source directory\r\n* `:generator`  - specify generator\r\n* `:build_parallel_level` - parallel jobs level","ref":"Mix.Tasks.Compile.Cmake.html#module-configuration","title":"Configuration - mix compile.cmake","type":"task"},{"doc":"There are several default environment variables set:\r\n\r\n  * `MIX_TARGET` => env(\"MIX_TARGET\", \"host\")\r\n  * `MIX_ENV` => to_string(Mix.env())\r\n  * `MIX_BUILD_PATH` => Mix.Project.build_path()\r\n  * `MIX_APP_PATH` => Mix.Project.app_path()\r\n  * `MIX_COMPILE_PATH` => Mix.Project.compile_path()\r\n  * `MIX_CONSOLIDATION_PATH` => Mix.Project.consolidation_path()\r\n  * `MIX_DEPS_PATH` => Mix.Project.deps_path()\r\n  * `MIX_MANIFEST_PATH` => Mix.Project.manifest_path()\r\n  * `ERL_EI_LIBDIR` => env(\"ERL_EI_LIBDIR\", erl_ei_lib_dir)\r\n  * `ERL_EI_INCLUDE_DIR` => env(\"ERL_EI_INCLUDE_DIR\", erl_ei_include_dir)\r\n  * `ERTS_INCLUDE_DIR` => env(\"ERTS_INCLUDE_DIR\", erts_include_dir)\r\n  * `ERL_INTERFACE_LIB_DIR` => env(\"ERL_INTERFACE_LIB_DIR\", erl_ei_lib_dir)\r\n  * `ERL_INTERFACE_INCLUDE_DIR` => env(\"ERL_INTERFACE_INCLUDE_DIR\", erl_ei_include_dir)","ref":"Mix.Tasks.Compile.Cmake.html#module-default-environment-variables","title":"Default environment variables - mix compile.cmake","type":"task"},{"doc":"# Mix Cmake\r\n\r\nMix Cmake is Elixir mix task to run Cmake build tool.","ref":"readme.html","title":"Mix Cmake","type":"extras"},{"doc":"Add following dependency to your `mix.exs`,\r\n\r\n```elixir\r\ndef deps do\r\n  [\r\n    {:mix_cmake, \"~> 0.1.5\"}\r\n  ]\r\nend\r\n```\r\n\r\nand compile `mix_cmake`.\r\n\r\n```shell\r\n$ mix deps.get\r\n$ mix deps.compile\r\n==> mix_cmake\r\n```\r\n\r\nOptionaly you can include some Cmake configuration as `cmake:` attribute in project/0 list.\r\n\r\n```elixir:mix.exs\r\ndef project do\r\n  [\r\n    ...\r\n    cmake: cmake()\r\n  ]\r\nend\r\n\r\ndef cmake() do\r\n  [\r\n    # Specify cmake build directory or pseudo-path {:local, :global}.\r\n    #   :local(default) - \"./_build/.cmake_build\"\r\n    #   :global - \"~/.\\#{Cmake.app_name()}\"\r\n    #\r\n    build_dir: :local,\r\n    \r\n    # Specify cmake source directory.(default: File.cwd!)\r\n    #\r\n    source_dir: File.cwd!,\r\n    \r\n    # Specify generator name.\r\n    # \"cmake --help\" shows you build-in generators list.\r\n    #\r\n    generator: \"MSYS Makefiles\",\r\n    \r\n    # Specify jobs parallel level.\r\n    #\r\n    build_parallel_level: 4\r\n  ]\r\nend\r\n```","ref":"readme.html#installation","title":"Installation - Mix Cmake","type":"extras"},{"doc":"At the first, you need to prepare the \"CMakeLists.txt\" for your project.\r\nMix Cmake can generate boiler plate \"CMakeLists.txt\" if you want. It also make a snipet of cmake/0 - Cmake configuration - including to `mix.exs`.\r\n\r\n```shell\r\n$ cd  \r\n$ mix cmake.init\r\n```\r\n\r\nAfter that, you will invoke sub-command `config`, `build` and `install` in order or invoke all in one command.\r\n\r\n```shell:sub command style\r\n$ mix cmake.config\r\n$ mix cmake.build\r\n$ mix cmake.install\r\n```\r\n\r\n```shell:all in one style\r\n$ mix cmake --config\r\n```\r\n\r\nOf course, `config` sub-command need to be run once. \"mix cmake\" with no options executes `build` and `install` only.\r\n\r\nYou can remove optupts built by Cmake to invoke sub-command `clean`.\r\n\r\n```shell\r\n$ mix cmake.clean\r\n```\r\n\r\nCAUTION: `clean`'s option `--all` means to remove WHOLE BUILD working directory. You will have to run `mix cmake.config` next time.","ref":"readme.html#basic-usage","title":"Basic Usage - Mix Cmake","type":"extras"},{"doc":"There is also a compiler task - Mix.Tasks.Compile.Cmake. You can execute cmake by invoking `mix compile`.\r\nIn this case, you need to add the following settings to `mix.exs`.\r\n\r\n```elixir\r\ndef project() do\r\n[\r\n  app: :myapp,\r\n  deps: deps(),\r\n  compilers: [:cmake] ++ Mix.compilers,\r\n  \r\n  cmake: [\r\n    build_dir: :local,\r\n    build_parallel_level: 4,\r\n    ...\r\n  ]\r\n]\r\nend\r\n```","ref":"readme.html#compiler-task","title":"Compiler Task - Mix Cmake","type":"extras"},{"doc":"Mix Cmake is licensed under the Apache License Version 2.0.","ref":"readme.html#license","title":"License - Mix Cmake","type":"extras"},{"doc":"# Release 0.1.5(Nov 29 2024)","ref":"changelog.html","title":"Release 0.1.5(Nov 29 2024)","type":"extras"},{"doc":"* Add option `trace`, `define`, `undef` and `recache` for cmake.config.\r\n        \r\n# Release 0.1.4(May 26 2023)","ref":"changelog.html#major-features-and-improvements","title":"Major Features and Improvements - Release 0.1.5(Nov 29 2024)","type":"extras"},{"doc":"* Added the ability to skip cmake.\r\n\r\n# Release 0.1.3(May 18 2022)","ref":"changelog.html#major-features-and-improvements","title":"Major Features and Improvements - Release 0.1.5(Nov 29 2024)","type":"extras"},{"doc":"* Add option `platform` and config setting `build_config`.\r\n\r\n# Release 0.1.2(Jan 30 2022)","ref":"changelog.html#major-features-and-improvements","title":"Major Features and Improvements - Release 0.1.5(Nov 29 2024)","type":"extras"},{"doc":"* Mix.Tasks.Compile.cmake will skip execution if the build directory exists.\r\n  You can invoke Mix.Tasks if you want to cmake config / build / install again.","ref":"changelog.html#breaking-changes","title":"Breaking Changes - Release 0.1.5(Nov 29 2024)","type":"extras"}],"producer":{"name":"ex_doc","version":"0.35.1"},"proglang":"elixir"}